------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Icons;
with Qt4.Sizes;
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Tab_Widgets is

   type Tab_Widget_Tab_Position is
    (North,
     South,
     West,
     East);
   pragma Convention (C, Tab_Widget_Tab_Position);

   type Tab_Widget_Tab_Shape is
    (Rounded,
     Triangular);
   pragma Convention (C, Tab_Widget_Tab_Shape);

   type Q_Tab_Widget is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Tab_Widget_Access is
     access all Q_Tab_Widget'Class;
   for Q_Tab_Widget_Access'Storage_Size use 0;

   type Q_Tab_Widget_Pointer is tagged;

   function Add_Tab
    (Self : not null access Q_Tab_Widget'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Label : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Add_Tab
    (Self : not null access Q_Tab_Widget'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Icon : Qt4.Icons.Q_Icon;
     Label : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   procedure Clear
    (Self : not null access Q_Tab_Widget'Class);

   function Count
    (Self : not null access constant Q_Tab_Widget'Class)
       return Qt4.Q_Integer;

   function Current_Index
    (Self : not null access constant Q_Tab_Widget'Class)
       return Qt4.Q_Integer;

   function Current_Widget
    (Self : not null access constant Q_Tab_Widget'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Icon_Size
    (Self : not null access constant Q_Tab_Widget'Class)
       return Qt4.Sizes.Q_Size;

   function Index_Of
    (Self : not null access constant Q_Tab_Widget'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class)
       return Qt4.Q_Integer;

   function Insert_Tab
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Label : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Insert_Tab
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Icon : Qt4.Icons.Q_Icon;
     Label : Qt4.Strings.Q_String)
       return Qt4.Q_Integer;

   function Is_Tab_Enabled
    (Self : not null access constant Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer)
       return Standard.Boolean;

   procedure Remove_Tab
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer);

   procedure Set_Icon_Size
    (Self : not null access Q_Tab_Widget'Class;
     Size : Qt4.Sizes.Q_Size);

   procedure Set_Tab_Enabled
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Enabled : Standard.Boolean);

   procedure Set_Tab_Icon
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Tab_Position
    (Self : not null access Q_Tab_Widget'Class;
     Position : Qt4.Tab_Widgets.Tab_Widget_Tab_Position);

   procedure Set_Tab_Shape
    (Self : not null access Q_Tab_Widget'Class;
     S : Qt4.Tab_Widgets.Tab_Widget_Tab_Shape);

   procedure Set_Tab_Text
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Label : Qt4.Strings.Q_String);

   procedure Set_Tab_Tool_Tip
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Tip : Qt4.Strings.Q_String);

   procedure Set_Tab_Whats_This
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String);

   procedure Set_Uses_Scroll_Buttons
    (Self : not null access Q_Tab_Widget'Class;
     Use_Buttons : Standard.Boolean);

   function Tab_Icon
    (Self : not null access constant Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Icons.Q_Icon;

   function Tab_Position
    (Self : not null access constant Q_Tab_Widget'Class)
       return Qt4.Tab_Widgets.Tab_Widget_Tab_Position;

   function Tab_Shape
    (Self : not null access constant Q_Tab_Widget'Class)
       return Qt4.Tab_Widgets.Tab_Widget_Tab_Shape;

   function Tab_Text
    (Self : not null access constant Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Tab_Tool_Tip
    (Self : not null access constant Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Tab_Whats_This
    (Self : not null access constant Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Uses_Scroll_Buttons
    (Self : not null access constant Q_Tab_Widget'Class)
       return Standard.Boolean;

   function Widget
    (Self : not null access constant Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Set_Current_Index
    (Self : not null access Q_Tab_Widget'Class;
     Index : Qt4.Q_Integer);

   procedure Set_Current_Widget
    (Self : not null access Q_Tab_Widget'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   package Q_Tab_Widget_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Tab_Widget, Q_Tab_Widget_Access);

   type Q_Tab_Widget_Pointer is
     new Q_Tab_Widget_Pointers.Q_Pointer with null record;

end Qt4.Tab_Widgets;
